VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.UserControl FolderSelect 
   ClientHeight    =   2505
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4395
   ScaleHeight     =   2505
   ScaleWidth      =   4395
   ToolboxBitmap   =   "FolderSelect.ctx":0000
   Begin VB.DirListBox FolderList 
      Height          =   1890
      Left            =   675
      TabIndex        =   2
      Top             =   525
      Width           =   3615
   End
   Begin MSComctlLib.ImageList imaDriveIcon 
      Left            =   75
      Top             =   525
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   6
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "FolderSelect.ctx":0314
            Key             =   "NetConnect"
            Object.Tag             =   "NetConnect"
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "FolderSelect.ctx":0766
            Key             =   "Removable"
            Object.Tag             =   "Removable"
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "FolderSelect.ctx":0BB8
            Key             =   "Floppy"
            Object.Tag             =   "Floppy"
         EndProperty
         BeginProperty ListImage4 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "FolderSelect.ctx":100A
            Key             =   "CDROM"
            Object.Tag             =   "CDROM"
         EndProperty
         BeginProperty ListImage5 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "FolderSelect.ctx":145C
            Key             =   "HD"
            Object.Tag             =   "HD"
         EndProperty
         BeginProperty ListImage6 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "FolderSelect.ctx":18AE
            Key             =   "NetDisConnect"
            Object.Tag             =   "NetDisConnect"
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.ImageCombo imacboDrive 
      Height          =   330
      Left            =   675
      TabIndex        =   0
      Top             =   75
      Width           =   3615
      _ExtentX        =   6376
      _ExtentY        =   582
      _Version        =   393216
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      ImageList       =   "imaDriveIcon"
   End
   Begin VB.Label lblDrive 
      Alignment       =   1  'Right Justify
      Caption         =   "Drive"
      Height          =   240
      Left            =   75
      TabIndex        =   1
      Top             =   150
      Width           =   465
   End
End
Attribute VB_Name = "FolderSelect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'///////////////////////////////////////////
'// Folder Select
'// Used as a better option to the drive
'// control in the standard controls

' Consts
    Private Const MIN_HEIGHT = 2505
    Private Const MIN_WIDTH = 4395
    Private Const MIN_NOCAPWIDTH = 3950

' Types (local var settings)
    Private Type tLocalSettings
        FontSize As Integer
        GetFloppyInfo As Boolean
        UseCurrentPathAsDefault As Boolean
        ShowRemovable As Boolean
        ShowNetwork As Boolean
        ShowCDROM As Boolean
    End Type

' Enums
    Public Enum eBorderStyle
        None = 0
        FixedSingle = 1
    End Enum

' Variables
    Private LocalSettings As tLocalSettings

' Events
    Public Event Error(ByVal ErrorString As String)

' Drive Image Combo
    Public Event DriveChange()
    Public Event DriveClick()
    Public Event DriveGotFocus()
    Public Event DriveKeyDown(KeyCode As Integer, Shift As Integer)
    Public Event DriveKeyPress(KeyAscii As Integer)
    Public Event DriveKeyUp(KeyCode As Integer, Shift As Integer)
    Public Event DriveLostFocus()
' Drive Label
    Public Event DriveLabelChange()
    Public Event DriveLabelClick()
    Public Event DriveLabelDblClick()
    Public Event DriveLabelMouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Public Event DriveLabelMouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Public Event DriveLabelMouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

' FolderList (dir)
    Public Event FolderListChange()
    Public Event FolderListClick()
    Public Event FolderListGotFocus()
    Public Event FolderListKeyDown(KeyCode As Integer, Shift As Integer)
    Public Event FolderListKeyPress(KeyAscii As Integer)
    Public Event FolderListKeyUp(KeyCode As Integer, Shift As Integer)
    Public Event FolderListLostFocus()
    Public Event FolderListMouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Public Event FolderListMouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Public Event FolderListMouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Public Event FolderListScroll()

Option Explicit

' Runnable Routines
Public Function Drive() As String
    Drive = Left(imacboDrive.Text, 3)
End Function

Public Function Folder() As String
    Dim sTmp As String
    
    sTmp = FolderList.Path
    
    Do
        DoEvents
        sTmp = Right(sTmp, Len(sTmp) - InStr(1, sTmp, "\"))
    Loop Until InStr(1, sTmp, "\") = 0
    
    Folder = sTmp
End Function

Public Function Path() As String
    Path = FolderList.Path
End Function

' Properties
Public Property Let BorderStyle(ByVal Value As eBorderStyle)
    If UserControl.BorderStyle <> Value Then
        UserControl.BorderStyle = Value
        PropertyChanged "BorderStyle"
    End If
End Property
Public Property Get BorderStyle() As eBorderStyle
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let Enabled(ByVal Value As Boolean)
    If FolderList.Enabled <> Value Then
        imacboDrive.Enabled = Value
        imacboDrive.BackColor = IIf(Value, vbWindowBackground, vbButtonFace)
        FolderList.Enabled = Value
        FolderList.BackColor = IIf(Value, vbWindowBackground, vbButtonFace)
        FolderList.ForeColor = IIf(Value, vbButtonText, vbGrayText)
        lblDrive.Enabled = Value
    End If
End Property
Public Property Get Enabled() As Boolean
    Enabled = FolderList.Enabled
End Property
    

Public Property Let ShowRemovableDrives(ByVal Value As Boolean)
    If Value <> LocalSettings.ShowRemovable Then
        LocalSettings.ShowRemovable = Value
        PropertyChanged "ShowRemovable"
    ' Since it's changed, reload the control
        EnumDrives
    End If
End Property
Public Property Get ShowRemovableDrives() As Boolean
    ShowRemovableDrives = LocalSettings.ShowRemovable
End Property

Public Property Let ShowNetworkDrives(ByVal Value As Boolean)
    If Value <> LocalSettings.ShowNetwork Then
        LocalSettings.ShowNetwork = Value
        PropertyChanged "ShowNetwork"
    ' Since it's changed, reload the control
        EnumDrives
    End If
End Property
Public Property Get ShowNetworkDrives() As Boolean
    ShowNetworkDrives = LocalSettings.ShowNetwork
End Property

Public Property Let ShowCDROMDrives(ByVal Value As Boolean)
    If Value <> LocalSettings.ShowCDROM Then
        LocalSettings.ShowCDROM = Value
        PropertyChanged "ShowCDROM"
    ' Since it's changed, reload the control
        EnumDrives
    End If
End Property
Public Property Get ShowCDROMDrives() As Boolean
    ShowCDROMDrives = LocalSettings.ShowCDROM
End Property

Public Property Let DriveCaption(ByVal Value As String)
    Dim lngWidth
    
    If lblDrive.Caption <> Value Then
        lblDrive.Caption = Value
        PropertyChanged "DriveCaption"
    ' OK, now see if we need resized
        lngWidth = UserControl.TextWidth(lblDrive.Caption)
        If lblDrive.Width <> lngWidth Then
            lblDrive.Width = lngWidth
        End If
    ' Resize control, just to make sure
        UserControl_Resize
    End If
End Property
Public Property Get DriveCaption() As String
    DriveCaption = lblDrive.Caption
End Property

Public Property Let UseCurrentPathAsDefault(ByVal Value As Boolean)
    If Value <> LocalSettings.UseCurrentPathAsDefault Then
        LocalSettings.UseCurrentPathAsDefault = Value
        PropertyChanged "UseCurrentPathAsDefault"
    End If
End Property
Public Property Get UseCurrentPathAsDefault() As Boolean
    UseCurrentPathAsDefault = LocalSettings.UseCurrentPathAsDefault
End Property

Public Property Let GetFloppyInfo(ByVal Value As Boolean) 'Get Floppy Drive Info?
    If LocalSettings.GetFloppyInfo <> Value Then
        LocalSettings.GetFloppyInfo = Value
        PropertyChanged "GetFloppyInfo"
    End If
End Property
Public Property Get GetFloppyInfo() As Boolean
    GetFloppyInfo = LocalSettings.GetFloppyInfo
End Property

Public Property Let FontSize(ByVal Value As Integer)
' Min/Max font sizes
    If Value < 6 Then
        Value = 6
    ElseIf Value > 18 Then
        Value = 18
    End If

' Set the font size, if different
    If LocalSettings.FontSize <> Value Then
        lblDrive.FontSize = Value
        imacboDrive.Font.Size = Value
    ' Store the current
        LocalSettings.FontSize = Value
        PropertyChanged "FontSize"
        UserControl_Resize
    End If
End Property
Public Property Get FontSize() As Integer
    FontSize = lblDrive.FontSize
End Property


' Normal Functions
Public Sub EnumDrives()
    Dim sExistingDrives As String
    Dim sCurDrive As String
    Dim i As Integer
    Dim DriveInfo As tVolumeInfo
    Dim sBuffer As String
    Dim iDriveType As Integer
    Dim CurrentFolder As tCurrentFolder
    
' Get the current drives & folder
    sExistingDrives = ExistingDrives
    CurrentFolder = GetCurrentFolder
    
' Clear the current listing
    imacboDrive.ComboItems.Clear
    
' Current drives are separated with a null char
    For i = 1 To Len(sExistingDrives) Step 4 ' length of a entire drive string
    ' Re-Init variable
        DriveInfo.ComponentLength = 0
        DriveInfo.FileSystem = ""
        DriveInfo.SystemFlags = 0
        DriveInfo.VolumeName = ""
    ' Get the drive name & type
        sCurDrive = Mid(sExistingDrives, i, 3)
        iDriveType = GetDriveType(sCurDrive)
    ' OK, now the case's are done twice for a reason...
    ' Get specifics, if done to removable media, with make noise if none inserted
        Select Case iDriveType
        Case 2
            If LocalSettings.GetFloppyInfo Then
                DriveInfo = GetVolumeInfo(sCurDrive)
            End If
        Case Else
            DriveInfo = GetVolumeInfo(sCurDrive)
        End Select
    ' All right, now format it so it looks neater
        sBuffer = sCurDrive
        If DriveInfo.VolumeName <> "" Or DriveInfo.FileSystem <> "" Then
            sBuffer = sBuffer & "  ("
            If DriveInfo.VolumeName <> "" And DriveInfo.FileSystem <> "" Then
                sBuffer = sBuffer & DriveInfo.VolumeName & " - " & DriveInfo.FileSystem
            ElseIf DriveInfo.FileSystem <> "" Then
                sBuffer = sBuffer & DriveInfo.FileSystem
            ElseIf DriveInfo.VolumeName <> "" Then
                sBuffer = sBuffer & DriveInfo.VolumeName
            End If
            sBuffer = sBuffer & ")"
        End If
    ' OK, now display the stuff
        Select Case GetDriveType(sCurDrive)
        Case 2
            If LocalSettings.ShowRemovable Then
                imacboDrive.ComboItems.Add , , sBuffer, imaDriveIcon.ListImages("Removable").Index
            End If
        Case 3
            imacboDrive.ComboItems.Add , , sBuffer, imaDriveIcon.ListImages("HD").Index
        Case 4
            If LocalSettings.ShowNetwork Then
                imacboDrive.ComboItems.Add , , sBuffer, imaDriveIcon.ListImages("NetConnect").Index
            End If
        Case 5
            If LocalSettings.ShowCDROM Then
                imacboDrive.ComboItems.Add , , sBuffer, imaDriveIcon.ListImages("CDROM").Index
            End If
        Case 6
            imacboDrive.ComboItems.Add , , sBuffer
        End Select
    Next
    If imacboDrive.ComboItems.Count > 0 Then
        If LocalSettings.UseCurrentPathAsDefault Then
            For i = 1 To imacboDrive.ComboItems.Count
                If Left(imacboDrive.ComboItems.Item(i), 3) = CurrentFolder.Drive Then
                    imacboDrive.ComboItems.Item(i).Selected = True
                End If
            Next
            FolderList.Path = CurrentFolder.Drive & CurrentFolder.Folder
        Else
            imacboDrive.ComboItems.Item(1).Selected = True
        End If
    End If
End Sub

Private Sub FolderList_Change()
    RaiseEvent FolderListChange
End Sub

Private Sub FolderList_Click()
    RaiseEvent FolderListClick
End Sub


Private Sub FolderList_GotFocus()
    RaiseEvent FolderListGotFocus
End Sub


Private Sub FolderList_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent FolderListKeyDown(KeyCode, Shift)
End Sub


Private Sub FolderList_KeyPress(KeyAscii As Integer)
    RaiseEvent FolderListKeyPress(KeyAscii)
End Sub


Private Sub FolderList_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent FolderListKeyUp(KeyCode, Shift)
End Sub


Private Sub FolderList_LostFocus()
    RaiseEvent FolderListLostFocus
End Sub


Private Sub FolderList_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent FolderListMouseDown(Button, Shift, X, Y)
End Sub


Private Sub FolderList_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent FolderListMouseMove(Button, Shift, X, Y)
End Sub


Private Sub FolderList_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent FolderListMouseUp(Button, Shift, X, Y)
End Sub


Private Sub FolderList_Scroll()
    RaiseEvent FolderListScroll
End Sub


Private Sub imacboDrive_Change()
    RaiseEvent DriveChange
    FolderList.Path = Left(imacboDrive.Text, 3)
End Sub

Private Sub imacboDrive_Click()
    RaiseEvent DriveClick
    FolderList.Path = Left(imacboDrive.Text, 3)
End Sub

Private Sub imacboDrive_GotFocus()
    RaiseEvent DriveGotFocus
End Sub

Private Sub imacboDrive_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent DriveKeyDown(KeyCode, Shift)
End Sub

Private Sub imacboDrive_KeyPress(KeyAscii As Integer)
    RaiseEvent DriveKeyPress(KeyAscii)
End Sub

Private Sub imacboDrive_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent DriveKeyUp(KeyCode, Shift)
End Sub

Private Sub imacboDrive_LostFocus()
    RaiseEvent DriveLostFocus
End Sub

Private Sub lblDrive_Change()
    RaiseEvent DriveLabelChange
End Sub

Private Sub lblDrive_Click()
    RaiseEvent DriveLabelClick
End Sub

Private Sub lblDrive_DblClick()
    RaiseEvent DriveLabelDblClick
End Sub

Private Sub lblDrive_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent DriveLabelMouseDown(Button, Shift, X, Y)
End Sub

Private Sub lblDrive_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent DriveLabelMouseMove(Button, Shift, X, Y)
End Sub

Private Sub lblDrive_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent DriveLabelMouseUp(Button, Shift, X, Y)
End Sub

Private Sub UserControl_Initialize()
    imacboDrive.ComboItems.Clear
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Dim iFontSize As Integer
    
' Check Floppy
    LocalSettings.GetFloppyInfo = PropBag.ReadProperty("GetFloppyInfo", False)

' Use Current Path as default
    LocalSettings.UseCurrentPathAsDefault = PropBag.ReadProperty("UseCurrentPathAsDefault", True)
    
' Fonts
    iFontSize = PropBag.ReadProperty("FontSize", 8)
    LocalSettings.FontSize = iFontSize
    lblDrive.FontSize = iFontSize
    imacboDrive.Font.Size = iFontSize
    
' Drive Label
    lblDrive.Caption = PropBag.ReadProperty("DriveCaption", "Drive")
    
' Show Drives
    LocalSettings.ShowNetwork = PropBag.ReadProperty("ShowNetwork", True)
    LocalSettings.ShowRemovable = PropBag.ReadProperty("ShowRemovable", True)
    LocalSettings.ShowCDROM = PropBag.ReadProperty("ShowCDROM", True)
    
' Form Properties
    Me.Enabled = PropBag.ReadProperty("Enabled", "true")
    Me.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    
' Display the drives
    EnumDrives
End Sub

Private Sub UserControl_Resize()
' Ok, First off, make sure we're not smaller than the min size
    If UserControl.Width < MIN_WIDTH Then
        If lblDrive.Caption = "" And UserControl.Width < MIN_NOCAPWIDTH Then
            UserControl.Width = MIN_NOCAPWIDTH
        Else
            UserControl.Width = MIN_WIDTH
        End If
    End If
    If UserControl.Height < MIN_HEIGHT Then
        UserControl.Height = MIN_HEIGHT
    End If

' First move the actual controls
    If lblDrive.Caption <> "" Then
        lblDrive.Move 75, 100, lblDrive.Width, imacboDrive.Height
        imacboDrive.Move lblDrive.Left + lblDrive.Width + 75, 75, UserControl.ScaleWidth - (lblDrive.Left + lblDrive.Width + 75) - 75
    Else
        imacboDrive.Move 75, 75, UserControl.ScaleWidth - 150
    End If
    FolderList.Move imacboDrive.Left, imacboDrive.Top + imacboDrive.Height + 75, imacboDrive.Width, UserControl.ScaleHeight - FolderList.Top - 75
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "GetFloppyInfo", LocalSettings.GetFloppyInfo, False
    PropBag.WriteProperty "FontSize", lblDrive.FontSize, 8
    PropBag.WriteProperty "UseCurrentPathAsDefault", LocalSettings.UseCurrentPathAsDefault, True
    PropBag.WriteProperty "DriveCaption", lblDrive.Caption, "Drive"
    PropBag.WriteProperty "ShowNetwork", LocalSettings.ShowNetwork, True
    PropBag.WriteProperty "ShowRemovable", LocalSettings.ShowRemovable, True
    PropBag.WriteProperty "ShowCDROM", LocalSettings.ShowCDROM, True
    PropBag.WriteProperty "Enabled", Me.Enabled
    PropBag.WriteProperty "BorderStyle", UserControl.BorderStyle
End Sub
